% =========================================================================
% Title         : acumen_plot.m
% Author        : Arend Aerts
% Project       : Model-Based testing tool for hybrid systems in Acumen
% Date          : 10-04-2015
% Description   : Plot specific variable from data struc [acumen]
%
%                                ---
%
% Copyright () 2010-2014, Acumen Individual Contributors (AIC)
% All rights reserved.
%
% See LICENSE-AIC for licensing details. 
% =========================================================================

%function [X1,Y1,X2,Y2]=JSON_plot4(testcase,acumen,tooling_mode,selected_var,selected_output)


testcase = handles.testcase;
acumen = handles.acumen;
    

contents=cellstr(get(handles.plotvar,'String')); 
selected_var = contents{get(handles.plotvar,'Value')};
contents2=cellstr(get(handles.selectoutput,'String'));
selected_output = contents2{get(handles.selectoutput,'Value')};
contents3=cellstr(get(handles.popupmenu24,'String'));
tmp = contents3{get(handles.popupmenu24,'Value')};
if ~isempty(strfind(tmp,'Matlab')) && ~isempty(handles.model_path) 
    handles.tooling_mode = 1;
    tooling_mode = 1;
else
    handles.tooling_mode = 0;
    tooling_mode = 0;
end


% Output selection --
if strcmp(selected_output,'Model output')
    special = 1;
else
    if strcmp(selected_output,'Implementation output')
        special = 2;
    else
        special = 3;
    end    
end

% Plot data --
if special == 1
    if tooling_mode == 1
        % Load data
        X1 = testcase.time;
        index=find(ismember(testcase.var,selected_var));
        Y1 = testcase.data(index,:);
    else
        % Load data
        X1 = acumen.time;
        index=find(ismember(acumen.var,selected_var));
        Y1 = acumen.data1(index,:);
    end

    % Plot specified variable
    plot(X1,Y1,'b','linewidth',2);
    grid on;
    xlabel('Time');
    ylabel('Value');
    title(selected_var);
    if tooling_mode == 1
        legend('Model [Matlab]');
    else
        legend('Model [Acumen]');
    end
end

if special == 2
    if acumen.instances > 1
        X1 = acumen.time;
        index=find(ismember(acumen.var,selected_var));
        Y1 = acumen.data2(index,:);
    else
        X1 = acumen.time;
        index=find(ismember(acumen.var,selected_var));
        Y1 = acumen.data1(index,:);
    end

    % Plot specified variable
    plot(X1,Y1,'r','linewidth',2);
    grid on;
    xlabel('Time');
    ylabel('Value');
    legend('Implementation [Acumen]');
    title(selected_var);
end

if special == 3
    if tooling_mode == 1
        % Load data
        X1 = testcase.time;
        index=find(ismember(testcase.var,selected_var));
        Y1 = testcase.data(index,:);
    else
        % Load data
        X1 = acumen.time;
        index=find(ismember(acumen.var,selected_var));
        Y1 = acumen.data1(index,:);
    end
    
    if acumen.instances > 1
        X2 = acumen.time;
        index=find(ismember(acumen.var,selected_var));
        Y2 = acumen.data2(index,:);
    else
        X2 = acumen.time;
        index=find(ismember(acumen.var,selected_var));
        Y2 = acumen.data1(index,:);
    end

    % Plot specified variable
    plot(X1,Y1,'b','linewidth',2);
    hold on;
    plot(X2,Y2,'k','linewidth',2);
    hold off;
    grid on;
    xlabel('Time');
    ylabel('Value');
    title(selected_var);
    if tooling_mode == 0
        legend('Model [Acumen]','Implementation [Acumen]');
    else
        legend('Model [Matlab]','Implementation [Acumen]');
    end
end


